-- GLOBALS: unpack, select, LibStub, ITEM_SEARCHBAR_LIST
-- GLOBALS: VoidStorageFrame, ReagentBankFrame, MerchantFrame

--[[//////////////////////////////////////////////////

    GLO-LO

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]

    local _G = _G
    local math = math
    local tostring = tostring
    local tonumber = tonumber
    local string = string
    local pairs = pairs
    local format = format
    local tinsert = tinsert
    local strmatch = strmatch
    local strsplit = strsplit

    local CreateFrame = CreateFrame
    local UIParent = UIParent
    local ResetCursor = ResetCursor
    local SetCursor = SetCursor
    local ShowInspectCursor = ShowInspectCursor
    local GameTooltip = GameTooltip
    local GameTooltip_Hide = GameTooltip_Hide
    local GameTooltip_ShowCompareItem = GameTooltip_ShowCompareItem
    local BattlePetToolTip_Show = BattlePetToolTip_Show
    local BattlePetTooltip = BattlePetTooltip
    local CloseDropDownMenus = CloseDropDownMenus
    local ToggleDropDownMenu = ToggleDropDownMenu
    local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo
    local UIDropDownMenu_SetWidth = UIDropDownMenu_SetWidth
    local UIDropDownMenu_Initialize = UIDropDownMenu_Initialize
    local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton
    local UseContainerItem = UseContainerItem
    local PickupContainerItem = PickupContainerItem
    local PickupGuildBankItem = PickupGuildBankItem
    local GetItemQualityColor = GetItemQualityColor
    local SplitContainerItem = SplitContainerItem
    local SplitGuildBankItem = SplitGuildBankItem
    local ClickVoidStorageSlot = ClickVoidStorageSlot
    local GetCurrentGuildBankTab = GetCurrentGuildBankTab
    local AutoStoreGuildBankItem = AutoStoreGuildBankItem
    local GetCVarBool = GetCVarBool
    local IsShiftKeyDown = IsShiftKeyDown
    local IsModifiedClick = IsModifiedClick
    local IsControlKeyDown = IsControlKeyDown
    local HandleModifiedItemClick = HandleModifiedItemClick
    local SocketContainerItem = SocketContainerItem
    local GetMoneyString = GetMoneyString
    local ColorPickerFrame = ColorPickerFrame
    local FauxScrollFrame_OnVerticalScroll = FauxScrollFrame_OnVerticalScroll
    local IsBagOpen, OpenBag = IsBagOpen, OpenBag
    local IsArtifactPowerItem = IsArtifactPowerItem
    local SocketInventoryItem = SocketInventoryItem
    local SpellCanTargetItem = SpellCanTargetItem
    local SpellCanTargetItemID = SpellCanTargetItemID
    local DressUpItemLink = DressUpItemLink
    local SplitStack = SplitStack
    local ContainerFrameItemButton_OnClick = ContainerFrameItemButton_OnClick
    local StackSplitFrame = StackSplitFrame

    local B, L, T = unpack(select(2, ...))
    B.Mail = {['Buttons'] = {}}


--[[//////////////////////////////////////////////////

    CREATE FRAME AND BUTTONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Mail:CreateFrame()
        
        T.F.mainframe.character.mail = CreateFrame("Frame", "BWcharactermail", T.F.mainframe.character, "BackdropTemplate")
        T.F.mainframe.character.mail:SetWidth(310)
        T.F.mainframe.character.mail:SetHeight(250)
        T.F.mainframe.character.mail:SetFrameStrata("HIGH")
        T.F.mainframe.character.mail.totalitems = 0
        T.F.mainframe.character.mail.money = 0
        T.F.mainframe.character.mail.cod = 0
        T.F.mainframe.character.mail:Hide()
        T.F.mainframe.character.mail:EnableMouse(true)
        T.F.mainframe.character.mail:SetScript("OnShow", self.Show)
        T.F.mainframe.character.mail:SetScript("OnHide", self.Hide)

        T.F.mainframe.character.mail.enddot = T.F.mainframe.character.mail:CreateTexture(nil, "OVERLAY")
        T.F.mainframe.character.mail.enddot:SetMask("Textures\\MinimapMask")
        T.F.mainframe.character.mail.enddot:SetHeight(5)
        T.F.mainframe.character.mail.enddot:SetWidth(5)
        T.F.mainframe.character.mail.enddot:SetTexture(T.MEDIABLANK)
        T.F.mainframe.character.mail.enddot:SetVertexColor(1, 1, 1, 1)
        T.F.mainframe.character.mail.enddot:SetPoint("TOP", T.F.mainframe.character.mail, "BOTTOM", 0, 12)

        B.I.CreateScroll(T.F.mainframe.character.mail, "FauxScrollFrameBWmail", B.Mail.Update, "BWmailScrollFrame", B.Mail.Buttons.Create, 28)
    end

    function B.Mail:Show()
        T.F.mainframe.character.mailtab:SetBackdropBorderColor(1, 1, 1, 1)
    end

    function B.Mail:Hide()
        T.F.mainframe.character.mailtab:SetBackdropBorderColor(0, 0, 0, 1)
    end


    function B.Mail:CreateTab()

        T.F.mainframe.character.mailtab = B.I.Tab.Create(T.F.mainframe.character, nil, "BackdropTemplate")
        T.F.mainframe.character.mailtab:SetPoint("TOPLEFT", T.F.mainframe.character.auctionstab, "BOTTOMLEFT", 0, -4)
        T.F.mainframe.character.mailtab:SetNormalTexture(B.GetMailIcon())
        T.F.mainframe.character.mailtab:HookScript("OnClick", self.Click)
        T.F.mainframe.character.mailtab:HookScript("OnEnter", self.Enter)
        T.F.mainframe.character.mailtab:SetScript("OnLeave", self.Leave)
    end

    function B.Mail:Click(...)

        T.F.mainframe.character.equipment:Hide()
        T.F.mainframe.character.auctions:Hide()
        --T.F.mainframe.farm:Hide()

        if T.F.mainframe.character.mail:IsVisible() then
            T.F.mainframe.character.mail:Hide()
        else
            B.Mail:Update()
            T.F.mainframe.character.mail:Show()
        end
    end

    function B.Mail:Enter()

        if T.F.mainframe.layout > 2 then
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", 10, -10)
        else
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT", -10, -10)
        end

        local text = L[9012]

        if T.F.mainframe.character.mail.totalitems == 50 then
            text = text.." (~"..T.F.mainframe.character.mail.totalitems.."*)"
        elseif T.F.mainframe.character.mail.totalitems > 0 then
            text = text.." ("..T.F.mainframe.character.mail.totalitems..")"
        end
        GameTooltip:SetText(text)

        if T.F.mainframe.character.mail.money > 0 then
            GameTooltip:AddLine(L[9008].." "..GetMoneyString(T.F.mainframe.character.mail.money, true))
        end
        if T.F.mainframe.character.mail.cod > 0 then
            GameTooltip:AddLine(L[9009].." "..GetMoneyString(T.F.mainframe.character.mail.cod, true))
        end
        GameTooltip:Show()
    end

    function B.Mail:Leave()
        GameTooltip:Hide()
    end


    function B.Mail.Buttons:Create()

        local button = B.I.TabList.Button(index, T.F.mainframe.character.mail.list)
        button:SetScript("OnEnter", B.Mail.Buttons.Enter)
        button:SetScript("OnLeave", B.Mail.Buttons.Leave)
        button:SetScript("OnClick", B.Mail.Buttons.Click)

        button.leftstring:SetPoint("LEFT", button.icon, "RIGHT", 10, 0)
        button.leftstring:SetPoint("RIGHT", button, "RIGHT", -button.rightstring.bg:GetWidth(), 0)

        button.rightstring.time:Hide()

        return button
    end

    function B.Mail.Buttons:Enter()

        local r, g, b = GetItemQualityColor(self.quality)
        self:SetBackdropBorderColor(r, g, b, 1)

        B.I.Button.Enter(self, false)
    end

    function B.Mail.Buttons:Leave()

        self:SetBackdropBorderColor(T.THEME.r, T.THEME.g, T.THEME.b, 1)
        GameTooltip:Hide()
    end

    function B.Mail.Buttons:Click()
        T.F.mainframe.searchbar:SetText(self.name)
    end


--[[//////////////////////////////////////////////////

    FUNCTIONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Mail:Scan()

        local x, a, index
        local mail = T['mail']
        local totalMoney, totalCOD = 0, 0
        local sender, money, CODAmount, daysLeft, itemCount
        local name, count

        table.wipe(mail[1])

        -- Can only load 50 mail
        for x = 1, GetInboxNumItems() do
            _, _, sender, _, money, CODAmount, daysLeft, itemCount = GetInboxHeaderInfo(x)

            if money > 0 then totalMoney = totalMoney + money end
            if CODAmount > 0 then totalCOD = totalCOD + CODAmount end

            if itemCount then
                index = #mail[1] + 1
                for a = 1, itemCount do
                    name, _, _, count = GetInboxItem(x, a)
                    mail[1][index] = B.Scan(mail[1][index], GetInboxItemLink(x, a), count)
                    if mail[1][index] then
                        mail[1][index]['time'] = GetTime() + (daysLeft*24*60*60)
                        mail[1][index]['money'] = money > 0 and money or CODAmount > 0 and -CODAmount or nil
                        mail[1][index]['sender'] = sender
                    end
                end
            end
        end

        mail['money'] = totalMoney
        mail['cod'] = totalCOD
    end


    function B.Mail:Update()

        local time, days = GetTime(), 0
        local r, g, b, k, v, idx, link, hexcolor, ilvl
        local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice
        local mail = B.GetPlayerBank('mail')
        local total_items = #mail[1]
        local currentscrollbarvalue = FauxScrollFrame_GetOffset(T.F.mainframe.character.mail.scroll)
        local rows = B.RowsToFit(T.F.mainframe.character.mail, 28)

        FauxScrollFrame_Update(T.F.mainframe.character.mail.scroll, total_items, rows, 28)
        for x = 1, rows do
            -- Clear buttons
            B.ResetButton(T.F.mainframe.character.mail.list.buttons[x])
            --T.F.mainframe.character.mail.list.buttons[x]:SetBackdropColor(T.THEME.r, T.THEME.g, T.THEME.b, T.THEME.a)
            T.F.mainframe.character.mail.list.buttons[x]:SetBackdropBorderColor(T.THEME.r, T.THEME.g, T.THEME.b, 1)
            T.F.mainframe.character.mail.list.buttons[x].leftstring:SetText("")
            T.F.mainframe.character.mail.list.buttons[x].rightstring.time:SetVertexColor(0.02, 0.76, 0.31, 1)
            --T.F.mainframe.character.mail.list.buttons[x].rightstring.bg:SetVertexColor(T.THEME.r, T.THEME.g, T.THEME.b, 1)
            T.F.mainframe.character.mail.list.buttons[x].rightstring:SetText("")
            T.F.mainframe.character.mail.list.buttons[x].rightstring:SetFont(T.F.mainframe.character.mail.list.buttons[x].rightstring:GetFont(), 12)
            T.F.mainframe.character.mail.list.buttons[x]:Hide()
            T.F.mainframe.character.mail.enddot:Hide()
        end

        for x = 1, rows do
            -- Get the appropriate item, which will be x + value
            local mail = mail[1]
            idx = x + currentscrollbarvalue

            if mail[idx] then
                if strmatch(mail[idx].link, "|Hbattlepet:") then
                    name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = B.GetPetInfo(mail[idx].link)
                else
                    name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture = GetItemInfo(mail[idx].link)
                end
                
                if name then
                    r, g, b, hexcolor = GetItemQualityColor(quality)

                    T.F.mainframe.character.mail.list.buttons[x].quality = quality
                    T.F.mainframe.character.mail.list.buttons[x].name = name
                    T.F.mainframe.character.mail.list.buttons[x].icon:SetTexture(texture)
                    T.F.mainframe.character.mail.list.buttons[x].leftstring:SetText("|c"..hexcolor..name.."|r")
                    T.F.mainframe.character.mail.list.buttons[x].rightstring.time:Hide()

                    days = (mail[idx].time - time)/24/60/60

                    if mail[idx].money and mail[idx].money < 0 then
                        T.F.mainframe.character.mail.list.buttons[x].rightstring:SetText(B.ASGSC(math.abs(mail[idx].money), false, nil, true, nil, 9))
                        if days < 1 then
                            T.F.mainframe.character.mail.list.buttons[x].rightstring.time:SetVertexColor(0.80, 0.16, 0.10, 1)
                        else
                            T.F.mainframe.character.mail.list.buttons[x].rightstring.time:SetVertexColor(0.87, 0.69, 0.14, 1)
                        end
                        T.F.mainframe.character.mail.list.buttons[x].rightstring.time:Show()
                    else
                        T.F.mainframe.character.mail.list.buttons[x].rightstring:SetFont(T.F.mainframe.character.mail.list.buttons[x].rightstring:GetFont(), 10)
                        T.F.mainframe.character.mail.list.buttons[x].rightstring:SetText(B.GetDays(days))
                    end

                    if mail[idx].count and mail[idx].count > 1 then
                        T.F.mainframe.character.mail.list.buttons[x].text:SetText(mail[idx].count)
                    end

                    if (class == L[9004] or class == L[9005]) and (quality and quality > 1) then -- ILVL for green quality or higher
                        ilvl = B.DetectILVL(link)
                        if ilvl then
                            T.F.mainframe.character.mail.list.buttons[x].ilvl:SetText(ilvl > 1 and ilvl or nil)
                            T.F.mainframe.character.mail.list.buttons[x].ilvl:SetTextColor(r, g, b, 1)
                        else
                            T.F.mainframe.character.mail.list.buttons[x].ilvl:SetText(iLevel > 1 and iLevel or nil)
                            T.F.mainframe.character.mail.list.buttons[x].ilvl:SetTextColor(r, g, b, 1)
                        end
                    end

                    T.F.mainframe.character.mail.list.buttons[x].link = mail[idx].link
                    T.F.mainframe.character.mail.list.buttons[x]:Show()
                    T.F.mainframe.character.mail.enddot:Show()
                    if idx == total_items then
                        T.F.mainframe.character.mail.enddot:Hide()
                    end
                end
            end
        end

        T.F.mainframe.character.mailtab:SetNormalTexture(B.GetMailIcon(total_items))
        T.F.mainframe.character.mail.totalitems = total_items
        T.F.mainframe.character.mail.money = mail['money'] or 0
        T.F.mainframe.character.mail.cod = mail['cod'] or 0
    end


    function B.Mail:Search(text)
        local item, link, info, temp, result
        local mail = B.GetPlayerBank('mail')[1]

        if not text then return end

        if next(mail) then
            for x = 1, #mail do

                link = mail[x]['link']
                info = strmatch(link, "|Hbattlepet:") and {B.GetPetInfo(link)} or {GetItemInfo(link)}

                temp = B.newtable()
                temp.name = info[1]
                temp.quality = info[3]
                temp.link = link
                temp.class = info[6]
                temp.subclass = info[7]
                temp.equipslot = info[9]

                if B.find(text, temp) then
                    result = T.BW.items("mail", 1, link) -- use metatable __call to group items
                    result['count'] = result['count'] + (mail[x]['count'] or 1)
                    T.F.mainframe.countbutton.count = T.F.mainframe.countbutton.count + (mail[x]['count'] or 1)
                end
            end
        end
    end


    function B.Mail:Clean(bank)

        local x
        local mail = bank or T['mail']
        local time = GetTime()

        for x = #mail[1], 1, -1 do
            if mail[1][x] then
                if mail[1][x]['time'] <= time then -- expired
                    table.remove(mail[1][x], x)
                end
            end
        end
    end

    function B.Mail:CleanAlts()

        local k, v, p, b

        for k, v in pairs(BWsavedtable) do
            if not T.OPTIONS[k] and type(v) == "table" then
                for p, b in pairs(v) do
                    if p ~= UnitName('player').."."..string.sub(UnitFactionGroup('player'), 1, 1) then
                        self:Clean(b['mail'])
                    end
                end
            end
        end
    end


--[[//////////////////////////////////////////////////

    POSITION

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Mail:Anchor(startpoint, endpoint, from, to)

        T.F.mainframe.character.mail:ClearAllPoints()
        T.F.mainframe.character.mail:SetPoint("TOP"..from, T.F.mainframe.character.equipmenttab, "TOP"..to)

        T.F.mainframe.character.mail.list:ClearAllPoints()
        T.F.mainframe.character.mail.list:SetPoint("TOP"..from, T.F.mainframe.character.mail)
        T.F.mainframe.character.mail.list:SetPoint("BOTTOM"..to, T.F.mainframe.character.mail)

        local x
        for x = 1, #T.F.mainframe.character.mail.list.buttons do
            T.F.mainframe.character.mail.list.buttons[x].rightstring.time:ClearAllPoints()
            T.F.mainframe.character.mail.list.buttons[x].rightstring.time:SetPoint(to, to == "RIGHT" and 2 or -2, 0)
        end
    end
